/**
 * Definiert Stra&szlig;enbahnen und stellt verschiedene Methoden bereit,
 * um diese zu simulieren.
 * 
 * @author Owyn
 * @version 2008-05-01
 */
public class Tram {
    
    /**
     * Liniennummer der Bahn.
     */
    int line;

    /**
     * Betriebsmodus der Bahn: true, falls die Bahn f&auml;hrt.
     */
    boolean driveMode;

    /**
     * Anzahl der Passagiere in der Bahn.
     */
    int passengers;

    /**
     * Initialisiert eine Stra&szlig;enbahn.
     *
     * @param line Liniennummer
     */
    Tram(int line) {
        this.line = line;
        driveMode = false;
        passengers = 0;
        System.out.println("Linie " + line + ": Betriebsbereit.");
    }

    /**
     * Abfahrt!
     */
    void drive() {
        driveMode = true;
        System.out.println("Linie " + line + ": In Fahrt.");
    }

    /**
     * Stopp!
     */
    void halt() {
        driveMode = false;
        System.out.println("Linie " + line + ": Gestoppt.");
    }

    /**
     * Lasse Passagiere einsteigen.
     *
     * @param n Anzahl der Passagiere
     */
    void getIn(int n) {
        if(driveMode) {
            System.out.println("Linie " + line + ": Einsteigen nicht moeglich - Bahn in Fahrt.");
        } else {
            passengers += n;
            System.out.println("Linie " + line + ": Es sind " +  n + " Passagiere eingestiegen.");
        }
    }

    /**
     * Lasse Passagiere aussteigen.
     *
     * @param n Anzahl der Passagiere
     */
    void getOut(int n) {
        if(driveMode) {
            System.out.println("Linie " + line + ": Aussteigen nicht moeglich - Bahn in Fahrt.");
        } else {
            if (n > passengers) {
                System.out.println("Linie " + line + ": So viele Passagiere sind nicht in der Bahn - Vorgang abgebrochen.");
            } else {
                passengers -= n;
                System.out.println("Linie " + line + ": Es sind " +  n + " Passagiere ausgestiegen.");
            }
        }
    }

}